/*
	Devabulator by Brian Fernandes
	Version: 1.4
	Email: infernalproteus@gmail.com
	Webpage: http://thegoan.com/devabulator
*/

var open = false;
//var lastY = 95;
//var item = null;

var CHECKED = "checked";
var FIXED = 3;
var sortIdx = -1;

var modList = {
	init: function() {
		this.itemList = new Array();
		var parts = preferences.mod_pref.value.split("\n");
		print("Number of parts is " + parts.length + " and B" + parts[0] + "B");
		if (parts.length < FIXED || parts[0].split("\r")[0] != "boost:popular") {
			print("Adding items");
			this.addItem("boost:popular", true);
			this.addItem("sort:time order:desc", false);
			this.addItem("sort:time order:asc", false);
			this.addItem("age_sigma:24h age_scale:50", false);
			this.addItem("by:dionyziz", false);
			this.addItem("by:crisvector", false);
			this.addItem("by:adonihs", false);
		}
		for (i = 0; i < parts.length; i++) {
			var p2 = parts[i].split("\r");
			this.addItem(p2[0], p2[1] == "true");
			print("Adding " + parts[i]);
		}
	},	
	
	addItem: function(text, checked) {
		if (!text || text.length == 0) return;
				
		var iCnt = this.itemList.length;
		var yLoc = (iCnt) ? (this.itemList[iCnt-1][1].vOffset + this.itemList[iCnt-1][1].height + 10) : 0; 
		
		var item = new TextArea();
		item.data = text;
		item.vOffset = yLoc;
		item.bgColor = "#FFFFFF";
//		item.bgOpacity = 200;
		item.width = 160;
		item.size = "10";
		item.hOffset = 20;
		
		var check = new Image();
		check.vOffset = yLoc;
		check.onMouseDown = "check(" + iCnt + ")";
		
		if (iCnt >= FIXED) {
			var cancel = new Image();
			cancel.src = "Images/cancel.png";
			cancel.vOffset = yLoc;	
			cancel.hOffset = item.hOffset + item.width + 3;		
			cancel.onMouseDown = "remove(" + iCnt + ")";
			cancel.tooltip = "Delete modifier";
			mod_list_frame.addSubview(cancel);		
		}
		
		mod_list_frame.addSubview(item);
		mod_list_frame.addSubview(check);
				
		this.updateUI();
		
		this.itemList[iCnt] = new Array();
		this.itemList[iCnt][0] = check;
		this.itemList[iCnt][CHECKED] = !checked; //we'll call toggle later, so setting the opposite value
		this.itemList[iCnt][1] = item;
		if (iCnt >= FIXED) {
			this.itemList[iCnt][2] = cancel;
		}
		
		//set some properties based on checked state
		this.check(iCnt);
	},
	
	updateUI: function() {
		modr_image.height = midv_image.height;
		mod_frame.height = midv_image.height;
		
		mod_list_frame.height = midv_image.height - 115; 
		list_sbar.height = mod_list_frame.height;	
		if (open) {
			//mod_frame is currently open
			list_sbar.hOffset = mid_image.width + midv_image.width + 3;
			mod_frame.hOffset = mid_image.width - 10;
		}
	},
	
	setDefaultSorting : function() {
		for (i = 0; i < FIXED; i++) {
			if (this.itemList[i][CHECKED]) {
				this.check(i);
				break;
			}
		}			
	},
	
	check: function(cnt) {
		var checkbox = this.itemList[cnt][0];
		var textarea = this.itemList[cnt][1];
		if (!this.itemList[cnt][CHECKED]) {		
			checkbox.src = "Images/checkbox-checked.png";
			checkbox.tooltip = "Deactivate modifier";
			textarea.editable = false;
			textarea.color = "#FFFFFF";
			textarea.bgOpacity = 0;
			textarea.style = "bold";
			this.itemList[cnt][CHECKED] = true;		
			sortIdx = cnt;
			
			if (cnt < FIXED) {
				//make sure the other two options are off
				if (this.itemList[(cnt+1)%FIXED]) {
					this.itemList[(cnt+1)%FIXED][CHECKED] = true;
					check((cnt+1)%FIXED);				
					
					if (this.itemList[(cnt+2)%FIXED]) {
						this.itemList[(cnt+2)%FIXED][CHECKED] = true;
						check((cnt+2)%FIXED);				
					}
				}
				
				/*if (cnt == 0) {
					preferences.browse_order_pref.value = 9;
				} else if (cnt == 1) {
					preferences.browse_order_pref.value = 5;
				} else {
					preferences.browse_order_pref.value = 6;
				}*/
			}	
		} else {
			checkbox.src = "Images/checkbox-unchecked.png";
			checkbox.tooltip = "Activate modifier";
			if (cnt >= FIXED) {
				textarea.editable = true;
				textarea.bgOpacity = 200;
				textarea.color = "#000000";
				textarea.style = "normal";
			} else {
				textarea.editable = false;
				textarea.bgOpacity = 0;
				textarea.color = "#FFFFFF";
				//textarea.style = "bold";
				/*if (cnt == sortIdx) {
					print("setting to one " + cnt + "," + sortIdx);
					preferences.browse_order_pref.value = 1;
				}*/
			}
			this.itemList[cnt][CHECKED] = false;
		}		
		
		pDeviations = null;
	}, 
	
	remove: function(cnt) {
		var len = this.itemList.length;
		var rItem = this.itemList[cnt];
		
		if (rItem[CHECKED]) pDeviations = null;
		
		var vOffset = rItem[0].vOffset;
		for (i = cnt; i < len - 1; i++) {
			this.itemList[i] = this.itemList[i+1];
			var temp = this.itemList[i][0].vOffset;
			this.itemList[i][0].vOffset = this.itemList[i][1].vOffset = this.itemList[i][2].vOffset = vOffset;
			this.itemList[i][0].onMouseDown = "check(" + i + ");";
			this.itemList[i][2].onMouseDown = "remove(" + i + ");";
			vOffset = temp;
		}
			
		this.itemList.pop();
		
		rItem[0].removeFromSuperview();
		rItem[1].removeFromSuperview();
		rItem[2].removeFromSuperview();
	},
	
	getModString: function() {
		var modString = "";
		for (i = 0; i < this.itemList.length; i++) {
			if (this.itemList[i][CHECKED]) {
				modString += "+" + this.itemList[i][1].data.replace(/ /g, "+");
			}
		}
		return modString;
	},
	
	getMods: function() {
		var mods = "";
		for (i = 0; i < this.itemList.length; i++) {
			var mod = this.itemList[i][1].data;
			if (mod.length == 0) continue;
			mods += "\n" + mod + "\r" + this.itemList[i][CHECKED];
		}
		return (mods.length > 0) ? mods.substring(1) : mods;				
	},
	
	fixLocation: function() {
		
		mod_list_frame.height = midv_image.height - 115;
		list_sbar.height = mod_list_frame.height;
	}
};

var list_sbar = new ScrollBar(main_window);
mod_list_frame.vScrollBar = list_sbar;
list_sbar.autoHide = true;
list_sbar.vOffset = mod_list_frame.vOffset + 20;
list_sbar.opacity = 0;

modList.init();

function showModMenu() {	
	var xt;
	if (!open) {
		xt = mid_image.width - 10;		
	} else {
		xt = mid_image.width / 2;
		list_sbar.opacity = 0;
	}	
	
	var animation = new Array();
	animation[0] = new MoveAnimation(mod_frame, xt, mod_frame.vOffset, MENU_SLIDE_DURATION, animator.kEaseIn);
	animation[1] = new FadeAnimation(mod_frame, open ? 0 : 255, MENU_SLIDE_DURATION, animator.kEaseNone);
	animator.runUntilDone(animation);	
	
	if (!open) {
		list_sbar.opacity = 255;
		list_sbar.hOffset = mid_image.width + midv_image.width + 3;
		list_sbar.height = mod_list_frame.height;
	}
	
	open = !open;	
}

function addItem() {
	modList.addItem(mod_text.data, false);
	mod_text.data = "";
}

function check(cnt) {
	modList.check(cnt);
}

function remove(cnt) {
	print("removing " + cnt);
	modList.remove(cnt);
}

function makeOffsetEditable() {
	off_text.editable = true;
	off_text.bgOpacity = 255;
	off_text.color = "#000000";
	off_text.style = "normal";
}

function makeOffsetUneditable() {
	off_text.editable = false;
	off_text.bgOpacity = 0;
	off_text.color = "#FFFFFF";
	//off_text.style = "bold";
}

function offsetChanged() {
	var key = system.event.key;
	var code = key.charCodeAt(0);
	if (code < '0'.charCodeAt(0) || code > '9'.charCodeAt(0)) {
		off_text.rejectKeyPress();
	}	
	if (code == 13) {
		var nOffset = off_text.data;
		if (isNaN(nOffset)) return;
		makeOffsetUneditable();
		nOffset = parseInt(nOffset);
		if (preferences.offset_pref.value != nOffset) {
			setCurrentOffset(nOffset);
			pDeviations = null;
		}
	}
}
